#!/bin/bash


basename=OnlySend
[ -n "$1" ] && basename="$1"
mode=.
#mode=.with_bootloader. # Don't do this. If a good bootloader is there, you
		# don't need to replace it.


processor=m328p
source 'inc/eeprom.sh-inc'
source 'inc/programmer.sh-inc'
source 'inc/get-station.sh-inc'
source 'inc/Xavrdude.sh-inc'

lead="$lead -D"

eepromfile=/tmp/m328p.eeprom


if [ \! -w "$serialport" ]; then
	printf '%s: ERROR: cann'"'"'t write to '"'%s'"'\n' "$0" "$serialport"
	false; exit
fi

station="`get_station`"
if [ \! $? = 0 ]; then
	printf >&2 "\n\n\n%s: Cann't determine station name!\n\n\n" "$0"
	false; exit
fi

printf "\n\n\nStation name is: %s\n\n\n" "$station"



#avrdude $lead -U "eeprom:v:built/$basename.ino.eep"
#echo $?


fullname="$basename.$station${mode}hex"
if [ \! -e "built/$fullname" ]; then
	printf '\nFile built/%s doesn'"'"'t exist!\n\n' "$0" "$fullname"
	false; exit
fi

Xavrdude $lead -U "flash:w:built/$fullname:i"

