
#ifndef SDERROR_H
#define SDERROR_H

// TODO: List here which methods have been altered and which haven't.



// SdErrorTrace[7:0]   = Method in which the error occured
// SdErrorTrace[15:8]  = Method which has directly called the error method.
// SdErrorTrace[23:16] = Method which has indirectly called the error method.
// SdErrorTrace[31:24] = Second Method which has indirectly called the err. m.
// In other words: this is a stack view:
// LSB  <-  Error source
// mean <-  subsequent calls
// MSB  <-  Call origin
extern uint32_t SdErrorTrace;

// returns false.
static uint8_t stamp_error(uint8_t error) {
	if (SdErrorTrace&0xFFFF) {
		if (SdErrorTrace & 0xFF000000) return false;
		if (SdErrorTrace &   0xFF0000)
			SdErrorTrace |= (uint32_t)error << 24;
		else
			SdErrorTrace |= (uint32_t)error << 16;
		return false;
	}
	if (SdErrorTrace & 0xFF) 
		SdErrorTrace |= (uint32_t)error << 8;
	else
		SdErrorTrace  = error;
	return false;
}

#define SD_SYNC 0x10
#define SD_SYNC_ERR_NOT_OPEN 0x11
#define SD_SYNC_ERR_CACHEDIRENTRY 0x12

#define SD_WRITE 0x14
#define SD_WRITE_ERR_FILEMOD 0x15

#define SD_ADDCLUSTER 0x1F

#define SD_CACHERAWBLOCK 0x20

#define SD_CACHEZEROBLOCK 0x22

#define SD_CACHEFLUSH_ERR_WRITEBLOCK 0x24
#define SD_CACHEFLUSH_ERR_WRITEBLOCK2  0x25

#define SD_FATGET 0x26
#define SD_FATGET_CLUSTERCOUNT 0x27



#define SD_WRITEBLOCK 0x30
#define SD_WRITEBLOCK_WE_DONT_ALLOW_BLOCK_ZERO 0x31
#define SD_WRITEBLOCK_ERR_CMD24 0x32
#define SD_WRITEBLOCK_ERR_TIMEOUT 0x33
#define SD_WRITEBLOCK_ERR_PROGRAMMING 0x34

#define SD_READBLOCK 0x36
#define SD_READBLOCK_ERR_CMD17 0x37
#define SD_READBLOCK_ERR_WAITSTARTBLOCK 0x38 // TODO: stamp waitStartBlock()
#define SD_READBLOCK_ERR_ARGUMENT_THIS_IS_YOUR_ERROR 0x39


#define SD_WRITEDATA_SPI_STATUS 0x3B


#define SD_IMPLANT_ERROR_ERROR 0x40


#endif // -ifndef SDERROR_H


