#!/bin/bash

targetname="$1"
if [ 1 -ne "`tr -d '\n' <<< "$targetname" | wc -c`" ]; then
	printf 'usage: %s N\n' "$0"
	printf '(where N is exactly 1 byte and denotes the new station name)\n'
	false; exit
fi

processor=m328p
source 'inc/eeprom.sh-inc'
source 'inc/programmer.sh-inc'
source 'inc/get-station.sh-inc'
source 'inc/Xavrdude.sh-inc'

eepromfile=/tmp/$processor.eeprom



# Find actual station name
get_station >/dev/null

if [ $? = 0 ]; then
	printf "Present station name: %c (0x%s)\n" "$stationname" "$stationnamehex"
else
	printf "No station name present so far. Newly creating it.\n"
	echo Station: | dd of="$eepromfile" bs=1 count=8 seek=$(($eepromsize-9)) conv=notrunc,nocreat status=none
fi

printf "Setting new station name to %c.\n" "$targetname"
printf %c "$targetname" \
| dd of="$eepromfile" bs=1 count=1 seek=$(($eepromsize-1)) conv=notrunc,nocreat status=none

printf "Finally writing eeprom:\n"
Xavrdude $lead -U eeprom:w:"$eepromfile":r
printf "Writing eeprom done.\n"


