

% © 2018 Jonas Bechtel
% Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



source("../../Dokument/common/octave-plot.include");



f1 = 1.025;
f2 = 1;
a1 = 2.5;
a2 = 1;
t=[0:.2:1200];

if (a1 < a2)
	fx = f1;
	f1 = f2;
	f2 = fx;
	ax = a1;
	a1 = a2;
	a2 = ax;
end

f1
f2
a1
a2

figure_start(51);
hold off;
HC = plot(t, a1*cos(t*f1+pi*.2)+a2*cos(t*f2), 'r'); hold on;
HA = plot(t, a1+a2*cos(t*abs(f1-f2)+.2*pi), lw,3, c,'g');
hold off

xlabel("Time in s")
ylabel("Amplitude")
axis([0, 500, -3.7, 5])

legend([HC; HA], {"Added sine waves";"Approximated envelope of added sine waves result."}, f,acc, "location", "north")

finish_optics(wide);
print ("-depsc2", ["air-envelope.eps"], Facc)
print ("-dpng", "-r450", ["air-envelope.png"], Facc)





figure_start(52);
hold off;
HC = plot(t, a1*cos(t*f1+pi*.2)+a2*cos(t*f2), 'r'); hold on;
HF1= plot(t, cos(t*f1+pi*.2), c,c_blau, lw,1.7);
HF2= plot(t, cos(t*f2), c,c_grau);
high = a1 + a2;
low = abs(a1 - a2)
HA = plot(t, (high+low)/2+(high - low)/2*cos(t*abs(f1-f2)+.2*pi), lw,3, c,'g');
hold off

xlabel("Time in s")
ylabel("Amplitude")
axis([80, 250, -1.4, 4.2])

legend([HC; HA;HF1;HF2], {"Added sine waves";"Approximated envelope of added sine waves result.";"Frequency of wave 1";"Frequency of wave 2"}, f,acc, "location", "northwest")

finish_optics(wide);
print ("-depsc2", ["air-freq.eps"], Facc)
print ("-dpng", "-r450", ["air-freq.png"], Facc)



