

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE


#ifndef STATION_APP_H
#define STATION_APP_H

#include "station.h"

#include "common/app-user.h"




struct station_app_methods {
	
	// This method only will be called when the routing algorithm's packet
	//  received method has been called.
	// The simulator (= station) has to return a reference to the send packet
	// in order to allow it's emission's cancellation.
	//
	// time: when to plan the packet's emission.
//	pid (*send_packet)(struct app_instance*, uint64_t time, struct packet*, struct radio_conf);
	
//	void (*cancel_packet)(struct app_instance*, pid);
	
	// Called by routing instance.
	// 
	void (*data_from_air)(struct app_instance*, uint64_t time, struct packet*);
	
	// Called by routing instance when preparing 
	// For practical C reasons this data cannot be revoken.
	// The returned data has to be freed by the routing instances.
	struct packet* (*data_to_send)(struct app_instance*);
};



void set_route_methods(struct station* st);


#endif // ifndef STATION_APP_H



