

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE


#ifndef STATION_H
#define STATION_H

#include <stdint.h>

#include "sim-common.h"


struct trigger_corroboration;

struct station_route_methods;
struct station_app_methods;

struct app_instance;
struct trancv_instance;

struct multihw_global_struct;

struct station {
	char name;
	
	void * dontuse1; // This is struct simulator, but only simulator.c knows.
	int dontuse2;   // This is the simulator index, but only simulator.c knows.
	
	uint64_t claimvar; // ONLY WRITABLE BY simulator.c
	void (*claim)(struct station * st, uint64_t claimtime);
	void (*quit)(struct station * st, const char* reason);
	void (*error)(struct station * st, const char* reason);
	void (*place_extra_answer)(struct station * st, struct trigger_corroboration);
	
	struct station_app_methods* am;
	
	struct app_instance * app;
	struct trancv_instance * trancv;
	struct multihw_global_struct * mgs;
};



#endif // ifndef STATION_H



