

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#include <stdio.h>
#include <string.h>

#define DEFINE_OBJECT // DEFINE_OBJECT is to be included only once in 
#include "subintern.h"  //    all application's code.
#undef DEFINE_OBJECT

#include "assert.h"

#include "sim-event.h" // CLAIM_INVALID

#include "RFM69trancv/subobject.h"
#include "RFM69trancv/RFM69-reg.h"
#include "RFM69trancv/RFM69-reghelper.h"
#define NOCODE
#include "multihw.c"
#include "simulator.c"  // quit()
#undef NOCODE

/*void receive_packet_DUMMYapp(struct app_instance* ai, 
				uint64_t time, struct packet* p, struct radio_conf rc) {
	// We received one packet and put exactly the same packet in back on air
	// 200 ms later.
	assert(0);
	//ai->station->am->send_packet(ai, time+200000, p, rc);
	
	
	printf("DUMMYroute: received packet. my_claim is: %'lu.\n", ai->my_claim);
}*/

void system_startup_DUMMY(struct app_instance* ai, uint64_t time) {
	struct station * mh_station_arg = ai->station;
	// The simulators' event loop is running now.
	
	//printf("DUMMYapp-%c: got startup.\n", ai->station->name);
	
	char name = ai->station->name;
	if (name == 'W') {
		ai->my_claim = time + 10 NSEC; // 0.010 us
	}
	else if (name == 'B') {
		ai->my_claim = time + 200 MSEC;
	}
	else if (name == 'C') {
		//ai->my_claim = time + 202 MSEC;
	}
	else if (name == 'D') {
		ai->my_claim = time + 204 MSEC;
	}
	
	if (ai->my_claim != CLAIM_INVALID) {
		ai->station->claim(ai->station, ai->my_claim);
		//ai->claim_want_send = true;
		ai->cl_send = ai->my_claim;
	}
	
	// Caution: in real life you would check some surrounding conditions
	// before!
	REGFILE_DO_WRITE(ai->station->trancv, cbMode, RFM_MODE_TX);
	REGFILE_DO_WRITE(ai->station->trancv, cbPacketFormat, PACKET_FORMAT_VARIABLElength);
}

struct trigger_corroboration notify_DUMMY(
			struct app_instance * ai, event e) {
	struct station * mh_station_arg = ai->station; // Needed for ulog.
	
	struct trigger_corroboration answer;
	answer.do_delay = 0;
	bool taken = 0;
	
	uint64_t simtime = get_simtime(mh_station_arg); //e.time;
	
	uint64_t errtime = 0;
	char* errstr = NULL;
	if (ai->cl_send < simtime) {
		errtime = ai->cl_send;
		errstr = "next sending time";
	}
	if (ai->cl_quit < simtime) {
		errtime = ai->cl_quit;
		errstr = "simulation quitting mechanism";
	}
	
	if (errstr) {
		printf ("app.c: Error: a claim of us was not taken! "
			"(Waiting for '%s' @%'lu)\n", errstr, errtime);
	}
	
	
	ulog_str_L("aEEEE\n");
	
	// TODO: How to coordinate the answer if multiple claims are hit at one time?
	if (ai->cl_send == simtime) {
		ai->cl_send = CLAIM_INVALID;
		taken = true;
		
		printf("aFFFF\n");
		
		// Always send "Who's Johnny?"
#define DUMMY_IS_SENDING "\n             X here." \
                         "\n             Who's Johnny?\n\n"
		
		int capacity = sizeof(DUMMY_IS_SENDING);
		struct digital_packet * packet;
		packet = malloc(sizeof (struct digital_packet) + (capacity - 1));
		if (packet == NULL) {
			answer.type = Error;
			answer.reason = "App: 'Couldn't allocate memory!.'";
			return answer;
		}
		packet->capacity = capacity;
		strncpy(packet->data, DUMMY_IS_SENDING, sizeof(DUMMY_IS_SENDING));
		packet->data[14] = ai->station->name;
		packet->datarate = 57600;
		packet->length = packet->capacity*8;
		
		struct wave_sequence* waves;
		printf("aGGGG\n");
		waves = ai->station->trancv->modulate_data(ai->station->trancv, packet);
		if (waves == NULL) {
			answer.type = Error;
			answer.reason  = "App: 'Receiver didn't do it's job!.'";
			return answer;
		}
		// waves->segmentation = (1 MSEC / packet->datarate) * packet->datarate;
		waves->segmentation = 1 MSEC;
		
		
		waves->refcount = 0;
		
		answer.type = to_air;
		answer.to_air = waves;
		printf("aHHHH\n");
		ai->station->place_extra_answer(ai->station, answer);
		printf("aIIII\n");
		
		if (ai->station->name == 'D') {
			ai->my_claim = simtime + 1 SEC;
			ai->cl_quit = ai->my_claim;
			printf("claim: %'lu ns\n", ai->cl_quit);
			ai->station->claim(ai->station, ai->my_claim);
		}
	}
	
	if (ai->cl_quit == simtime) {
		quit(ai->station, "somebody has to do it");
	}
	
	
	if (!taken) {
		//printf("app.c: WARNING: claim triggered @%'lu but we didn't expect"
		//	" anything then.\n", simtime);
	}
	
	
	answer.type = nop;
	return answer;
}

int start_DUMMYapp(struct app_instance * ai) {
	
	struct station * mh_station_arg = ai->station;
	log_str_L("\n\n\n\n");
	ulog_str_L("Hello, here's station '");
	log_str_N((char*)&ai->station->name, 1);
	log_str_L("'. :-)\n");
	
	
	
	
	ai->my_claim = CLAIM_INVALID;
	
	ai->system_startup = system_startup_DUMMY;
	ai->notify = notify_DUMMY;
	
	ai->cl_send = CLAIM_INVALID;
	ai->cl_quit = CLAIM_INVALID;
	
	
	ai->station->trancv = new_RFM69trancv(ai->station);
	if (!ai->station->trancv) {
		printf("DUMMYapp: Error: Couldn't instantiate RFM69trancv!\n");
		return OBJECT_START_FAIL;
	}
	
	int res = start_RFM69trancv(ai->station->trancv);
	if (res != OBJECT_START_OK)
		return res;
	
	// default: 433.56 MHz
	set_frequency(ai->station->trancv, 433560000);
	
	set_deviation(ai->station->trancv, 7500);
	
	always_receive(ai->station->trancv, true);
	
	return OBJECT_START_OK;
}


