

% © 2018 Jonas Bechtel
% Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



if (!exist("infile") || !ischar(infile))
	%clear asdfkajsldkjf
	%exist(asdfkajsldkjf)
	infile = "autographic/amr_received_aodv_-100dBm_W";
	printf ("WARNING: PLEASE PROVIDE infile IF YOU WANT YOUR OWN RESULTS!\n");
end
load("-text", infile)
if(exist("inbase"))
	base = [inbase "--"];
else
	base = "";
end
if (!exist("sent_frame_count"))
	maximum_count =                    select1(size(select1)(1),1);
	maximum_count = max(maximum_count, select2(size(select2)(1),1));
	maximum_count = max(maximum_count, select3(size(select3)(1),1));
	maximum_count = max(maximum_count, select4(size(select4)(1),1));
	maximum_count = max(maximum_count, select5(size(select5)(1),1));
	maximum_count = max(maximum_count, select6(size(select6)(1),1))
	total_frame_count = maximum_count;
else
	total_frame_count = sent_frame_count
end

source("../../Dokument/common/octave-plot.include");

function [] = standard_legend(POS)
	legend("received once", "received twice", "received three times", ...
		"received four times", "received five times", "received six or more times", "location", POS);
end

% W: We go from primary TU color (1 reception) to station main color (6+ receptions)
stepping_W = (cW - c_blau) / 5;
stepping_D = (cD - c_blau) / 5;

if (station_number == 4)
	stepping = stepping_D;
	c_station = cD;
else
	stepping = stepping_W;
	c_station = cW;
end

c6 = c_blau;
c5 = c_blau + 1*stepping;
c4 = c_blau + 2*stepping;
c3 = c_blau + 3*stepping;
c2 = c_blau + 4*stepping;
c1 = c_blau + 5*stepping;




% Complete overview of when the frames arrive
figure_start(1)
plot(select1(:,3)/1000000, select1(:,1), l,n, lw,1.2, m,'x', ms,12, c, c1)
plot(select2(:,3)/1000000, select2(:,1), l,n, lw,1.2, m,'+', ms,10, c, c2)
plot(select3(:,3)/1000000, select3(:,1), l,n, lw,1.1, m,'o', ms,8, c, c3)
plot(select4(:,3)/1000000, select4(:,1), l,n, lw,1.1, m,'d', ms,6, c, c4)
plot(select5(:,3)/1000000, select5(:,1), l,n, lw,1.0, m,'s', ms,4, c, c5)
plot(select6(:,3)/1000000, select6(:,1), l,n, lw,1.0, m,'h', ms,2, c, c6)
ylabel ("received AMR source frame number", f,acc)
xlabel ("time in ms", f,acc)
standard_legend("southeast")
print_ticks_1_000_000("x")
print_ticks_1_000("y")
finish_optics(wide)
print ("-depsc", [base "arrival.eps"], Facc)
%print ("-dsvg", [base "arrival.svg"], Facc)
print ("-dpng", "-r450", [base "arrival.png"], Facc)


% Somewhat more detailed
figure_start(2)
plot(select1(:,3)/1000000, select1(:,1), l,n, lw,1.4, m,'x', ms,8, c, c1)
plot(select2(:,3)/1000000, select2(:,1), l,n, lw,1.4, m,'+', ms,8, c, c2)
plot(select3(:,3)/1000000, select3(:,1), l,n, lw,1.4, m,'o', ms,8, c, c3)
plot(select4(:,3)/1000000, select4(:,1), l,n, lw,1.4, m,'d', ms,8, c, c4)
plot(select5(:,3)/1000000, select5(:,1), l,n, lw,1.4, m,'s', ms,8, c, c5)
plot(select6(:,3)/1000000, select6(:,1), l,n, lw,1.4, m,'h', ms,8, c, c6)
%axis([1.485e6, 1.61e6, 72500, 80000]);
detailed_center_index = find (select1(:,1) > 76500)
if (size(detailed_center_index)(1) > 0) 
	detailed_center_index = detailed_center_index(1);
	center_number = select1(detailed_center_index,1);
	center_time = select1(detailed_center_index,3)/1000000;
	axis([center_time-47000   center_time+47000   center_number - 2333   center_number + 2333])
	set(gca, "ygrid", "on")
	set(gca, "xgrid", "on")
	%axis([1.5036e+06   1.5984e+06   7.4205e+04   7.8872e+04])
	ylabel ("received AMR source frame number", f,acc)
	xlabel ("time in ms", f,acc)
	standard_legend("southeast")
	print_ticks_1_000_000("x")
	print_ticks_1_000("y")
	finish_optics(medium)
	%print -depsc2 arrival-detail.eps -FAccanthisADFStd-Regular
	%print -depsc2 arrival-detail.eps -FLiberation Serif:7
	%print ("-deps", [base "arrival-detail.eps"], Facc)
	%print ("-dpng", [base "arrival-detail.png"], "-FAccanthisADFStd-Regular:8")
	print ("-depsc", [base "arrival-detail.eps"], Facc)
	print ("-dpng", "-r450", [base "arrival-detail.png"], Facc)
end

% Complete overview of received sequence number against overall sequence number
figure_start(3)
plot(select1(:,1), select1(:,2), l,n, lw,1.0, m,'d', ms,3, "color", c1)
plot(select2(:,1), select2(:,2), l,n, lw,1.0, m,'d', ms,3, "color", c2)
plot(select3(:,1), select3(:,2), l,n, lw,1.0, m,'d', ms,3, "color", c3)
plot(select4(:,1), select4(:,2), l,n, lw,1.0, m,'d', ms,3, "color", c4)
plot(select5(:,1), select5(:,2), l,n, lw,1.0, m,'d', ms,3, "color", c5)
plot(select6(:,1), select6(:,2), l,n, lw,1.0, m,'d', ms,3, "color", c6)
axis([-9000,370000+030000, -40, 1064+750]);
ylabel ("transmitted sequence number", f,acc)
xlabel ("AMR source frame number", f,acc)
standard_legend("north")
print_ticks_1_000("x")
set(gca, "ytick", [0, 255, 511, 767, 1023])
finish_optics(wide)
print ("-depsc", [base "seqno.eps"], Facc)
print ("-dpng", "-r450", [base "seqno.png"], Facc)



% Detail with slanting lines
figure_start(4)
plot(select1(:,1), select1(:,2), l,n, lw,1.0, m,'d', ms,6, "color", c1)
plot(select2(:,1), select2(:,2), l,n, lw,1.0, m,'d', ms,6, "color", c2)
plot(select3(:,1), select3(:,2), l,n, lw,1.0, m,'d', ms,6, "color", c3)
plot(select4(:,1), select4(:,2), l,n, lw,1.0, m,'d', ms,6, "color", c4)
plot(select5(:,1), select5(:,2), l,n, lw,1.0, m,'d', ms,6, "color", c5)
plot(select6(:,1), select6(:,2), l,n, lw,1.0, m,'d', ms,6, "color", c6)
axis([34800,58000, -40, 1064+750]);
ylabel ("transmitted sequence number", f,acc)
xlabel ("AMR source frame number", f,acc)
standard_legend("north")
print_ticks_1_000("x")
set(gca, "ytick", [0, 255, 511, 767, 1023])
finish_optics(wide)
print ("-depsc", [base "seqno-detail.eps"], Facc)
print ("-dpng", "-r450", [base "seqno-detail.png"], Facc)

%graphics_toolkit fltk
maximum_arr = select0(size(select0)(1),1);
thediff = maximum_arr - sent_frame_count

figure_start(5)
sizes = [
		size(select0)(1)-thediff
		size(select1)(1)
		size(select2)(1)
		size(select3)(1)
		size(select4)(1)
		size(select5)(1)
		size(select6)(1)];
% https://lists.gnu.org/archive/html/help-octave/2014-03/msg00258.html
% Bar plot with logarithmic scale on y-axis, Juan Pablo Carbajal / Ben Abbott
% facecolor is only for legend.
%B1 = bar([0 1 2 3 4 5 6], sizes, "basevalue", 1, "hist", ...
%		"facecolor", c_station, "edgecolor", c_station, lw, 5);
%B2 = bar([-1.5], [count_not_found], "basevalue", 1, "facecolor", c_grau, ...
%		"edgecolor", c_grau, lw,5, "barwidth", .5);
function [H] = do_fill (pos, count, color)
	dist = .5;
	border_width = .2;
	log_factor = .6;
	vertices = [...
				pos-dist                  1; ...
				pos-dist+border_width     1; ...
				pos-dist+border_width     count*log_factor; ...
				pos+dist-border_width     count*log_factor; ...
				pos+dist-border_width     1; ...
				pos+dist                  1; ...
				pos+dist                  count; ...
				pos-dist                  count];
	H = fill(vertices(:,1), vertices(:,2), color, "edgecolor", color);
end
function [H] = do_line (pos, top, color)
	top = top*1.02;
	%linewidth = .01
	%vertices = [...
	%	pos-linewidth/2 1;
	%	pos+linewidth/2 1;
	%	pos+linewidth/2 top;
	%	pos-linewidth/2 top];
	%H = fill(vertices(:,1), vertices(:,2), color, "edgecolor", color);
	H = line([pos, pos], [1, top], "color", color, "linewidth", 1.5);
end

loaded=size(select0)(1) - (maximum_arr - loaded_frame_count);
     do_fill(6, sizes(7),c_station);
     do_fill(5, sizes(6),c_station);do_line(5.5,max(sizes(6),sizes(7)),[1,1,1]);
     do_fill(4, sizes(5),c_station);do_line(4.5,max(sizes(5),sizes(6)),[1,1,1]);
     do_fill(3, sizes(4),c_station);do_line(3.5,max(sizes(4),sizes(5)),[1,1,1]);
     do_fill(2, sizes(3),c_station);do_line(2.5,max(sizes(3),sizes(4)),[1,1,1]);
B2 = do_fill(1, sizes(2),c_station);do_line(1.5,max(sizes(2),sizes(3)),[1,1,1]);
BL = do_fill(0, loaded  ,c_grau);   
BS = do_fill(0, sizes(1),c_blau   );do_line(0.5,max(loaded,sizes(2)),[1,1,1]);
B1 = do_fill(-1.5, count_not_found, 'k');

set(gca, "yscale", "log")
set(gca, "xtick", [-1.5, 0, 1, 2, 3, 4, 5, 6])
function [out] = mystr(number)
	if (number < 1000)
		out = num2str(number);
	else
		out = [num2str(round(number/1000)) "k"];
	endif
end
set(gca, "xticklabel", {...
	["X: " mystr(count_not_found)], ...
	["t=0: " mystr(sizes(1))], ...
	["t=1: " mystr(sizes(2))], ...
	["t=2: " mystr(sizes(3))], ...
	["t=3: " mystr(sizes(4))], ...
	["t=4: " mystr(sizes(5))], ...
	["t=5: " mystr(sizes(6))], ...
	["t>5: " mystr(sizes(7))], ...
})
axis([-2.3 6.7 1 1.3e7])
ylabel("Number of frames which arrived selected number of times", f,acc);
grid on
legend([B2; B1; BL; BS], {"AMR frames sent and arrived t times"; "X: AMR frames arrived but unidentifyable"; "AMR frames loaded but not arrived*"; "AMR frames sent but not arrived"})
set(get(B1, "children"), "FaceAlpha", 0)
set(get(B2, "children"), "FaceAlpha", 0)
finish_optics(medium)
set (gca, "ytickmode", "auto");
set (gca, "yminorgrid", "on");
set (gca, "xminorgrid", "off");
print ("-depsc", [base "arrival-bars.eps"], Facc)
print ("-dpng", "-r450", [base "arrival-bars.png"], Facc)



