

% © 2018 Jonas Bechtel
% Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



infile="autographic/radio_reception_register"

load("-text", infile);

source("../../Dokument/common/octave-plot.include");

i = 1;
while i <= size(rrr_data)(1)
	if (strncmp(rrr_paramsets(i,:), "bcloop_-1000dBm", 15))
		D = i;
	elseif (strncmp(rrr_paramsets(i,:), "bcloop_-100dBm", 14))
		E = i;
	elseif (strncmp(rrr_paramsets(i,:), "bcloop_-20dBm", 13))
		F = i;
	elseif (strncmp(rrr_paramsets(i,:), "aodv_-1000dBm", 13))
		A = i;
	elseif (strncmp(rrr_paramsets(i,:), "aodv_-100dBm", 12))
		B = i;
	elseif (strncmp(rrr_paramsets(i,:), "aodv_-20dBm", 11))
		C = i;
	end
	i = i + 1;
end

A+B+C+D+E+F % if this fails then please run simulation for _all_ profiles first!

figure_start(10)

back=[5,4,3,2,1];
HB1000 = plot([1:5], rrr_data(D,back), '-', lw, 4, c,c_blau);
HB100  = plot([1:5], rrr_data(E,back), ':', lw, 3, c,c_blau);
HB20   = plot([1:5], rrr_data(F,back), '-', lw, 2.0, c,c_blau);
HA1000 = plot([1:5], rrr_data(A,back), '-', lw, 4, c,c_grau);
HA100  = plot([1:5], rrr_data(B,back), ':', lw, 3, c,c_grau);
HA20   = plot([1:5], rrr_data(C,back), '-', lw, 2.0, c,c_grau);

plot(5*ones(rrr_setcount,1), rrr_data(:,1), 'p', "color", cW, mfc, cW);
plot(4*ones(rrr_setcount,1), rrr_data(:,2), 'p', "color", cB, mfc, cB);
plot(3*ones(rrr_setcount,1), rrr_data(:,3), 'p', "color", cC, mfc, cC);
plot(2*ones(rrr_setcount,1), rrr_data(:,4), 'p', "color", cD, mfc, cD);
plot(1*ones(rrr_setcount,1), rrr_data(:,5), 'p', "color", cO, mfc, cO);
axis([0.2, 5.8, axis()(3), axis()(4)*1.8])
set(gca, "xtick", back)
set(gca, "xticklabel", ...
		["Station W"; "Station B"; "Station C"; "Station D"; "Station O"])
set(gca, "ytick", [0, 100, 200, 300, 400, 500, 600, 700, 800])
set(gca, "ygrid", "on")

% dBms is now ecrm/ecrms
ylabel("Registered radio reception in ecrms", f,acc);

legend([HA20; HA100; HA1000; HB20; HB100; HB1000], ...
	"AODV w/threshold -20 dBm",
	"AODV w/threshold -100 dBm",
	"AODV w/threshold -1000 dBm",
	"Broadcast w/threshold -20 dBm",
	"Broadcast w/threshold -100 dBm",
	"Broadcast w/threshold -1000 dBm")

finish_optics(medium)
print ("-depsc2", ["autographic/rrr-overview.eps"], Facc)
print ("-dpng", "-r450", ["autographic/rrr-overview.png"], Facc)
