

% © 2018 Jonas Bechtel
% Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE




% Data from /Sim/Dosim/time_consumption.txt
% DO NOT CHANGE

paramsets = [
"AODV, -20 dBm threshold"
"AODV, -100 dBm threshold"
"AODV, -1000 dBm threshold"
"Broadcast, -20 dBm threshold"
"Broadcast, -100 dBm threshold"
"Broadcast, -1000 dBm threshold"
];


% [real user sys]
WRONGtimes = [
148.786  115.782   60.835; % XXXXX
238.544  263.997   63.748; % XXXXX
240.471  306.213   64.265; % XXXXX
179.550  148.165   60.309; % XXXXX
266.695  228.646   65.242; % XXXXX
273.308  238.197   65.899  % XXXXX
];

% [real user sys]
times = [
151.244  117.340   62.700; % OK
239.949  203.412   67.783; % OK
248.786  214.285   64.779; % OK
182.795  151.851   60.025; % OK
268.226  231.670   66.015; % OK
271.486  235.269   66.769  % OK
];


source("../../Dokument/common/octave-plot.include");


figure_start(20)
BT = bar([1, 2, 3]    , times(1:3,2)+times(1:3,3), 'b');
BU = bar([1, 2, 3]    , times(1:3,2), 'g');
     bar([1, 2, 3]+4.0, times(4:6,2)+times(4:6,3), 'b');
     bar([1, 2, 3]+4.0, times(4:6,2), 'g');
xlabel("Parameter set: Routing method and receiver threshold in dBm");
ylabel("CPU Time consumption in seconds");
set(gca, "ygrid", "on")
legend([BU; BT], {"userland time only", "total time"}, "location", "northwest");
set(gca, "xtick", [0.35 1:3 4.2 5:7]);
set(gca, "xticklabel", {"AODV:"; "-20"; "-100"; "-1000"; "Broadcast:"; "-20"; "-100"; "-1000"});
finish_optics(medium)
print ("-depsc", "time-consumption.eps", Facc)
print ("-dpng", "-r450", "time-consumption.png", Facc)

