/*****************************************************************************
 *
 * Copyright (C) 2001 Uppsala University & Ericsson AB.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Authors: Erik Nordstrm, <erik.nordstrom@it.uu.se>
 *          
 *
 *****************************************************************************/
#ifndef _PARAMS_H
#define _PARAMS_H

//#include "defs.h"

#define K                       5

/* Dynamic configuration values. Default numbers are for HELLO messages. */
//#define ACTIVE_ROUTE_TIMEOUT hi->active_route_timeout
//#define TTL_START hi->ttl_start
//#define DELETE_PERIOD hi->delete_period

/* Settings for Link Layer Feedback */
#define ACTIVE_ROUTE_TIMEOUT_LLF    10000
#define TTL_START_LLF               1
#define DELETE_PERIOD_LLF           ACTIVE_ROUTE_TIMEOUT_LLF

/* Settings for HELLO messages */
//#define ACTIVE_ROUTE_TIMEOUT_HELLO  3000
#define ACTIVE_ROUTE_TIMEOUT_HELLO  3500
//#define ACTIVE_ROUTE_TIMEOUT_HELLO  6000 // Wil be used for other timeouts as well.
#define TTL_START_HELLO             2
#define DELETE_PERIOD_HELLO         K * max(ACTIVE_ROUTE_TIMEOUT_HELLO, ALLOWED_HELLO_LOSS * HELLO_INTERVAL)



/* Non runtime modifiable settings */

#ifdef CN_PORT
#define NET_DIAMETER            7 // With 15 addresses, this is the maximum.
#define TTL_START_AMR             NET_DIAMETER
// See file Broadcast-Loop-Prevention.odt
//#define TTL_BCLOOP_TIMEOUT    1190 // expecting AMR packets to arrive every 20 ms
#define TTL_BCLOOP_TIMEOUT      PATH_DISCOVERY_TIME
#else
#define NET_DIAMETER            35
#endif

#define ALLOWED_HELLO_LOSS      2
/* If expanding ring search is used, BLACKLIST_TIMEOUT should be?: */
#define BLACKLIST_TIMEOUT(ttl_start)       RREQ_RETRIES * NET_TRAVERSAL_TIME + (TTL_THRESHOLD - (ttl_start))/TTL_INCREMENT + 1 + RREQ_RETRIES
#define HELLO_INTERVAL          1000
#define LOCAL_ADD_TTL           2
#define MAX_REPAIR_TTL          3 * NET_DIAMETER / 10
#define MY_ROUTE_TIMEOUT(active_route_timeout)        2 * (active_route_timeout)
#define NET_TRAVERSAL_TIME      2 * NODE_TRAVERSAL_TIME * NET_DIAMETER
#define NEXT_HOP_WAIT           NODE_TRAVERSAL_TIME + 10
//#define NODE_TRAVERSAL_TIME     40
//#define NODE_TRAVERSAL_TIME     3000 // 3 seconds is one ALOHA frame.
#define NODE_TRAVERSAL_TIME     1500
//#define NODE_TRAVERSAL_TIME     1000 // 1 second  is main slice -> main slice.
#define PATH_DISCOVERY_TIME     2 * NET_TRAVERSAL_TIME
#define RERR_RATELIMIT          10
#define RING_TRAVERSAL_TIME     2 * NODE_TRAVERSAL_TIME * (TTL_VALUE + TIMEOUT_BUFFER)
#define RREQ_RETRIES            2
#define RREQ_RATELIMIT          10
#define TIMEOUT_BUFFER          2
#define TTL_INCREMENT           2
#define TTL_THRESHOLD           7

// if this is defined the seek list will use this:
#define DISCOVERY_INTERVAL      1000
#define PRECEDENCE_OF_NEW_SIMILAR_ROUTES 1 // 1: don't keep old route if new one comes with same hop count. // set to 0 otherwise.

#endif				/* _PARAMS_H */
