#!/bin/sh
# Licence see below


if [ \! -p "$1" ]; then
	printf "%s: please give fifo to read from!\n" "$0"
	exit
fi

fifo=$1
#execute="valgrind ../aodvd $2"
execute="../aodvd $2"
shift; shift

echo '#!/bin/sh' >  ./$fifo.sh
echo 'read line' >> ./$fifo.sh
chmod a+x ./$fifo.sh
#echo 'echo "$line"' >> ./$fifo.sh

found=
while [ -n "$1" ]; do
	if [ -z "$2" ]; then
		printf "%s: usage: <fifo_read> [<fifo1_write> <delay1> [<fifo2_write> <delay2> [...]]]\n" "$0"
		exit
	fi
	
	printf '(sleep %s; cat <<< "$line" > %s) &\n' $2 $1 >> ./$fifo.sh
	found=y
	
	fifos="$fifos $1"
	
	shift
	shift
done

if [ \! $found = y ]; then
	printf "%s: no receiving stations given.\n" "$0"
	exit
fi

printf "\n\n\n\n\n\n"


touch $fifo.START
(sleep 2; [ -e $fifo.START ] && echo > $fifo) &
cat $fifo > /dev/null # Flush fifo
rm $fifo.START

touch ./$fifo.run
while [ -f $fifo.run ]; do 
	cat $fifo
done \
	| while read line; do
		if grep -E '^P' >/dev/null <<<$line; then \
			printf >&2 "%s <- %s <-\n" $fifo "$line"
		fi
		cat <<< "$line"
	done \
	| $execute \
	| while read line; do
		if grep -E '^P' >/dev/null <<<$line; then \
			printf "%s -> %s ->\n" $fifo "$line"
			cat <<< "$line" | ./$fifo.sh 
		elif grep -E '^Q$' >/dev/null <<<$line; then \
			rm ./$fifo.run
			echo quit | ./$fifo.sh
			for f in $fifos; do
				(sleep 2; echo > ./$f) &
			done
		else
			cat <<< "$line"
		fi
	done


rm ./$fifo.sh





#*****************************************************************************
#*
#* Copyright (C) 2018 Jonas Bechtel
#*
#* This program is free software; you can redistribute it and/or modify
#* it under the terms of the GNU General Public License as published by
#* the Free Software Foundation; either version 2 of the License, or
#* (at your option) any later version.
#*
#* This program is distributed in the hope that it will be useful,
#* but WITHOUT ANY WARRANTY; without even the implied warranty of
#* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#* GNU General Public License for more details.
#*
#* You should have received a copy of the GNU General Public License
#* along with this program; if not, write to the Free Software
#* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#*
#* Authors: Jonas Bechtel, <post@jjjjbechtel.de> (nospam: use jbechtel.de)
#*          
#*
#*****************************************************************************/





