
#include <sys/types.h>
#include <sys/socket.h>
#include <stdio.h>
#include <sys/ioctl.h>
#include <string.h> // strcpy
#include <unistd.h> // close
#include <linux/if.h>
#include <netinet/in.h>
#include <errno.h>

void main() {
	struct sockaddr_in *ina;
	int retw, iw_sock;
	char buf[1024];
	struct ifconf ifc;
	struct ifreq ifreq;
	
	iw_sock = socket(PF_INET, SOCK_DGRAM, 0);
	ifc.ifc_len = sizeof(buf);
	ifc.ifc_buf = buf;
	
	if (ioctl(iw_sock, SIOCGIFCONF, &ifc) < 0) {
		fprintf(stderr, "Could not get wireless info\n");
		return;
	}
	
	strcpy(ifreq.ifr_name, "teth0");
	
#define REQNAME SIOCGIFNETMASK
	retw = ioctl(iw_sock, REQNAME, &ifreq);
	close(iw_sock);
	
	if(retw < 0) {
		fprintf(stderr, "Error: ioctl failed with num %d (errno=%d: %s).\n", retw, errno, strerror(errno));
		return;
	}
	
	ina = (struct sockaddr_in *) &ifreq.ifr_addr;
	
	struct in_addr adr = ina->sin_addr;
	
	printf("in_addr");
}




