

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



// This file is generally broken - test routines shall be updated.


#include <stdlib.h>
#include <string.h>


#include "routeobject.h"

pid send_packet(struct routing_instance* ri, uint64_t time, struct packet* p, struct radio_conf rc) {
	char* str = (char*) ri->station->opaque;
	str[1] = 'O';
	return 1; // TODO: More values than one.
}

void cancel_packet(struct routing_instance* ri, pid packet) {
	// Do nothing ... this is only a test.
}


int main() {
#define S_(x) #x
#define S(x) S_(x)
	printf (__FILE__ ": Checking for " S(ROUTING_ALGO_NAME) "route ...\n");
	
	
	char* str = "BLAA";
	
	struct station st;
	st.opaque = NULL;
	st.rm = malloc (sizeof (struct station_route_methods));
	if(st.rm == NULL)
		goto fail;
	printf("Setting up methods.\n");
	st.rm->send_packet = send_packet;
	st.rm->cancel_packet = cancel_packet;
	
	printf("opaque = %p\n", st.opaque);
	struct routing_instance * ri = new_route_instance(&st);
	if (ri == NULL)
		goto fail;
	if (ri->station == NULL)
		goto fail;
	int res = start_route_module(ri);
	ri->station->opaque = str;
	if (st.opaque == NULL)
		goto fail;
	
	printf("opaque = %p\n", st.opaque);
	st.opaque = malloc (strlen(str) + 1);
	strcpy((char*) st.opaque, str);
	
	
	uint64_t times[] = {0, 10, 100, 1000, 10000, 100000, 1000000, 10000000};
	struct radio_conf rc = {.channel = 0, .signal_strength = 0, .transmission_speed = 57600};
	int i;
	printf("receive_packet = %p\n", ri->receive_packet);
	for (i = 0; i < sizeof(*times); i++) {
		ri->receive_packet(ri, times[i], NULL, rc);
	}
	
	printf ("%s -> %s.\n", str, (char*)(st.opaque));
	
	if(0 != strncmp("BOAA", (char*)(st.opaque), strlen(str)))
		goto fail;
	
	ri->destroy(ri);
	
	printf (__FILE__ ": Checked for " S(ROUTING_ALGO_NAME) "route -> all fine.\n");
	
	return 0;
	
	
fail:
	printf (__FILE__ ": Checked for " S(ROUTING_ALGO_NAME) "route -> FAIL!\n");
	return 1;
}





