

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#ifndef ROUTE_USER_H
#define ROUTE_USER_H

#include "object.h"

struct obj_instance(OBJ_NAME);

#include "sim-common.h"
#include "station-route.h"




#define ROUTE_INSTANCE_HEADER \
	struct station* station; \
	const char* thename; \
	void (*inbound_raw)(struct route_instance*, uint64_t time, uint8_t* data, uint8_t len, float power_in_mW); \
	uint16_t (*outbound_unpacked)(struct route_instance*, uint8_t* data, uint8_t len, uint8_t destination); \
	void (*service_task)(struct route_instance*); /*To be called time by time*/\
	\
	/* This is called by route instance itself; the pointers shall be provided \
	   by the application */ \
	void (*inbound_unpacked)(struct route_instance*, uint64_t time, void* data, uint8_t len, uint16_t seq, uint8_t src, uint8_t dst, float power_in_mW); \
	/*returns true on successful queuing*/ \
	/*if data is NULL: testrun.*/\
	bool (*outbound_raw)(struct route_instance*, uint8_t* data, uint8_t len, uint32_t tracking_mark); \
	\
	void (*destroy)(struct route_instance*); \

	// destroy_ri is preset.
	// When you replace this, please take care that the old function (free)
	// will be called as the last action of the new function.
	


#ifndef SKIP_OI
	struct route_instance {
		ROUTE_INSTANCE_HEADER
	};
#endif


#endif // #ifndef ROUTE_USER_H










