

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#ifndef RFM69_REGHELPER
#define RFM69_REGHELPER


#include "RFM69trancv/RFM69-reg.h"

#ifndef NOCODE
#define NOCODE
#include "RFM69trancv/trancv.c"
#include "multihw.c"
#undef NOCODE
#else
#include "RFM69trancv/trancv.c"
#include "multihw.c"
#endif


#define ERROR_YOU_MAY_NOT_READ_THIS_VARIABLE 0xfefefefe

extern uint8_t regfile_write_tmp;


#ifdef SIMUL
#define xTI_USE(trancv_instance) trancv_instance,
#else
#define xTI_USE(trancv_instance)
#endif


//uint8_t rfm_spi_read(uint8_t addr);
//void rfm_spi_write(uint8_t addr, uint8_t data);
#define REGFILE_DO_READ(trancv_instance, cb) \
			(regfile_is_read(cb) \
			?	(rfm_spi_read_single(xTI_USE(trancv_instance)  regfile_name(cb)) \
					>> regfile_bitshift(cb)) & regfile_bitmask(cb) \
			:	ERROR_YOU_MAY_NOT_READ_THIS_VARIABLE)
#define REGFILE_DO_WRITE(trancv_instance, cb_variable, data) \
	if (regfile_write_needs_read(cb_variable)) { \
		regfile_write_tmp = rfm_spi_read_single(xTI_USE(trancv_instance)  regfile_name(cb_variable)); \
		/*printf("Read: 0x%x.\n", regfile_write_tmp);*/ \
		regfile_write_tmp &= 0xff ^ (regfile_bitmask(cb_variable) << regfile_bitshift(cb_variable)); \
		/*printf("Masked: 0x%x.\n", regfile_write_tmp);*/ \
		regfile_write_tmp |= ((data) & regfile_bitmask(cb_variable)) << regfile_bitshift(cb_variable); \
	} \
	else { \
		regfile_write_tmp = (data) << regfile_bitshift(cb_variable); \
	} \
	rfm_spi_write_single(xTI_USE(trancv_instance)  regfile_name(cb_variable), regfile_write_tmp);
	
	
#if defined SILENT_REG_ACCESS


#define REGFILE_SILENT_READ(trancv_instance, cb) \
	cb == cbFifo \
		?	ERROR_YOU_MAY_NOT_READ_THIS_VARIABLE \
		:	(regfile_is_read(cb) \
			?	(trancv_instance->regfile[regfile_name(cb)] \
					>> regfile_bitshift(cb)) & regfile_bitmask(cb) \
			:	ERROR_YOU_MAY_NOT_READ_THIS_VARIABLE)
// regfile_write can be used like a function call (don't exceed the C syntax peculiarities)
// "returns" 1 if the variable is writable and 0 otherwise.
// TODO: writing RxBW or BitRate may return errors on real hardware as BitRyte <! 2*RxBw (3.4.6)
#define REGFILE_SILENT_WRITE(trancv_instance, cb_variable, data) \
	assert2((cb_variable) != cbFifo, "Wrong access, please access fifo in other ways!"); \
	\
	/*Clear the bits*/ \
	trancv_instance->regfile[regfile_name(cb_variable)] &= \
					0xff ^ (regfile_bitmask(cb_variable) << regfile_bitshift(cb_variable)); \
	\
	/*Set the new bits*/ \
	trancv_instance->regfile[regfile_name(cb_variable)] |= \
					((data) & regfile_bitmask(cb_variable)) << regfile_bitshift(cb_variable); 

// only use this for initialization!
#define REGFILE_FORCE_WRITE(trancv_instance, cb, data) \
		REGFILE_DO_WRITE(trancv_instance, (cb) | (REGFILE_WRITE << 16), data)

#endif // if defined SILENT_REG_ACCESS



#endif // -ifndef RFM69_REGHELPER
