

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#ifndef DUMMYintern_H
#define DUMMYintern_H

#define SKIP_INSTANCE
#include "common/trancv-user.h"

#include <stdbool.h> // bool


//#include "RFM69-nofifo.h"
#include "RFM69-reg.h"

struct trancv_instance {
	TRANCV_INSTANCE_HEADER
	
	// How big's the receivers' frequency mistake.
	uint32_t frequency_mistake; // Hz
	
	bool fdev_warned;
	
	char mode; // 'C' = Continuous Mode , 'P' = Packet Mode
	
	
	
	// Reading intermediate state
	uint8_t state; // 0 startup, 1 preamble, 2 sync, 3 len, 4 addr, 5 data, [6 crc not implemented]
	bool last_bit;
	uint32_t reading_tmptime; // ns, different meaning dependend on state
	uint8_t data_count;
	uint8_t packet_length;
	bool reading_buffer[160]; // A sync word must fit 2x in here. (up to 2*8*8 bits)
	
	uint32_t bit_length; // How long is 1 bit (for output)
	uint32_t bit_length_sync; // How long is 1 bit (bit syncronizer)
	uint32_t consumed_bittime; // What's the recent state of consumed_bittime
		// (consequently there should be a time reference saved but we don't
		//  do this here. It is rather some random influence which is supposed 
		//  to be rectified by the preamble)
	bool consumed_bitval;
	uint64_t consumed_fintime;
	
	uint8_t rssi_queued; // Only made available on RssiStart.
	uint64_t rssi_queue_time;
	
	// Convenience // TODO: unneeded?
	uint8_t cvflags; // cvflags & 0x01  = fixed_packet?1:0
	
	bool always_receive;
	//bool in_sending_process;
	//time_int tx_ready_start; // tx not ready if 0.
	uint64_t packet_sent_at;
	
	
	
	uint8_t fifo_ptr;
#define FIFO_SIZE 66
	uint8_t fifo[FIFO_SIZE];
	uint8_t regfile[0x72]; // Detailed information see RFM69-reg.h.
};
	
// Used function-internal in modulate_data and persistent in demodulate_data.
#define STATE_STARTUP 0 // (TODO: implement)
#define STATE_PREAMBLE 1 // reading preamble.
#define STATE_SYNC 2 // (TODO: implement)
#define STATE_LEN 3 // (TODO: implement)
#define STATE_ADDR 4 // (TODO: implement)
#define STATE_DATA 5 // (TODO: implement)
#define STATE_CRC 6 // (not implemented)
#define STATE_TOOMUCH 7 // [Only for modulate_data]




#include "subobject.h"

#undef SKIP_INSTANCE

#endif // ifndef DUMMYintern_H



