

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#ifdef NOCODE
#include "subobject.h"
#else
#include <string.h>
#include "RFM69intern.h"  //    all routing algorithm's code.
#endif


#include "RFM69-reghelper.h"



#if defined BEAGLE || defined ARDU

#define TI_ARG
#define TI_ARGS 
#define TI_USE
#define TI_USE2
#define TI_USES

#else // -if defined BEAGLE || defined ARDU

#define TI_ARGS struct trancv_instance* ti
#define TI_ARG  TI_ARGS ,
#define TI_USE  ti->
#define TI_USE2 ti,
#define TI_USES ti

#endif // -if defined BEAGLE || defined ARDU  -else



void RFM_put_on_fifo(TI_ARG    uint8_t data)
#ifndef NOCODE
{
	REGFILE_DO_WRITE(TI_USES, cbFifo, data);
}
#endif
;


#ifdef SIMUL
void RFM_convenience_prepare(TI_ARG    bool fixed_packet)
#ifndef NOCODE
{
	TI_USE cvflags &= 0xFE;
	TI_USE cvflags |= fixed_packet?1:0;
	
	if (fixed_packet) {
		REGFILE_DO_WRITE(TI_USES, cbPacketFormat, PACKET_FORMAT_FIXEDlength);
	}
	else {
		REGFILE_DO_WRITE(TI_USES, cbPacketFormat, PACKET_FORMAT_VARIABLElength);
	}
}
#endif
;
#endif

#ifdef SIMUL
// Only for lengths which fit into Fifo (~ 66 byte)
uint8_t RFM_send(TI_ARG    char* data, uint8_t len)
#ifndef NOCODE
{
	if (TI_USE cvflags & 0x01) {
		REGFILE_DO_WRITE(TI_USES, cbPayloadLength, len);
	}
	else {
		RFM_put_on_fifo(TI_USE2 len);
	}
	
	uint8_t space = FIFO_SIZE - TI_USE fifo_ptr;
	if (space < len) 
		len = space;
	
	memcpy(&(TI_USE fifo[TI_USE fifo_ptr]), data, len);
	return len;
}
#endif
;
#endif



time_int get_rx_startup_time(TI_ARGS)
#ifndef NOCODE
{
	// TODO: Be more precise. We are assuming worst case here.
	
/* From datasheet, p. 37:
 * 
 *   Tana + Tcf + Tdcc
 * ---- Received Packet Preamble may start ----
 *   3* Trssi + 2* tcf + Tdcc + Tafc + Tpllafc
 * ---- RxReady = 1 ----
 * 
 * with
 * Tana = 20 us
 * Tcf[FSK] = 21/(4*RxBw)
 * Tddc = max(8, 2^(round(log2(8*RxBw*Tbit)+1))/(4*RxBw))
 * Tpllafc = 5/PLLBW = 1/60kHz
 * Tafc = 4*Tbit
 * Trssi = 2*int(4*RxBw*Tbit)/(4*RxBw)
 * 
 * with RxBw[FSK] = FXOSC/(RxBwMant*2^(RxBwExp+2))
 * with 1/(4*RxBw) = (RxBwMant*2^(RxBwExp+2))/(4*FXOSC)
 */
	
/*
	float divisor = exp2f(2+REGFILE_DO_READ(TI_USES, cbRxBwExp));
	divisor *= REGFILE_DO_READ(TI_USES, cbRxBwMant);
	float rxbw = (float)FXOSC / divisor;
	
	time_int Tana = 20000000; // 20 us
	time_int Tcf = 21000000000 * divisor; Tcf /= 4*FXOSC;
	time_int Tdcc = divisor / (2*FXOSC) * (8*rxbw*1.5*get_bit_length(TI_USES));
	time_int Tpllafc = 5000000000 / 300000;
	time_int Tafc = 4* get_bit_length(TI_USES);
	time_int Trssi = 2* get_bit_length(TI_USES); // from p. 14
	
	
	return Tana + 3* Tcf + 2* Tdcc + 3* Trssi + Tafc + Tpllafc;*/
	
	// Doesn't fit to datasheet, p. 14.
	return 250000; // 250 USEC
}
#endif
;



