

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#include <stdlib.h>
#include <string.h>


#include "appobject.h"

pid send_packet(struct app_instance* ai, uint64_t time, struct packet* p, struct radio_conf rc) {
	char* str = (char*) ai->station->opaque;
	str[1] = 'O';
	return 1; // TODO: More values than one.
}

void cancel_packet(struct app_instance* ri, pid packet) {
	// Do nothing ... this is only a test.
}


int main() {
#define S_(x) #x
#define S(x) S_(x)
	printf (__FILE__ ": Checking for " S(APP_NAME) "app ...\n");
	
	
	char* str = "BLAA";
	
	struct station st;
	st.opaque = NULL;
	st.am = malloc(sizeof (struct station_app_methods));
	if (st.am == NULL)
		goto fail;
	printf("Setting up methods.\n");
	st.am->send_packet = send_packet;
	st.am->cancel_packet = cancel_packet;
	
	printf("opaque = %p\n", st.opaque);
	struct app_instance * ai = new_app_instance(&st);
	if (ai == NULL)
		goto fail;
	if (ai->station == NULL)
		goto fail;
	int res = start_app_module(ai);
	ai->station->opaque = str;
	if (st.opaque == NULL)
		goto fail;
	
	printf("opaque = %p\n", st.opaque);
	st.opaque = malloc (strlen(str) + 1);
	strcpy((char*) st.opaque, str);
	
	
	uint64_t times[] = {0, 10, 100, 1000, 10000, 100000, 1000000, 10000000};
	struct radio_conf rc = {.channel = 0, .signal_strength = 0, .transmission_speed = 57600};
	int i;
	printf("receive_packet = %p\n", ai->receive_packet);
	for (i = 0; i < sizeof(*times); i++) {
		ai->receive_packet(ai, times[i], NULL, rc);
	}
	
	printf ("%s -> %s.\n", str, (char*)(st.opaque));
	
	if(0 != strncmp("BOAA", (char*)(st.opaque), strlen(str)))
		goto fail;
	
	ai->destroy(ai);
	
	printf (__FILE__ ": Checked for " S(APP_NAME) "app -> all fine.\n");
	
	return 0;
	
	
fail:
	printf (__FILE__ ": Checked for " S(APP_NAME) "app -> FAIL!\n");
	return 1;
}





