

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE





#ifndef SUB_NAME
#error "You can't include this from outside!"
#endif







// Every module has to implement start_SUBobj():

// opaque will be given a pointer which has space for one pointer.
// returns 1 on success and 0 on failure
int startobj(SUB_NAME, OBJ_NAME) (struct obj_instance(OBJ_NAME)*);


#ifdef DEFINE_OBJECT
#include <stdlib.h> // free()
#endif



#define finaldestroyX(sub, obj) final_destroy_ ## sub ## obj

void finaldestroy(SUB_NAME, OBJ_NAME) (struct obj_instance(OBJ_NAME)* oi)
#ifdef DEFINE_OBJECT
{
	if (!oi)
		return;
	
	printf("Station %c: Final stat of trancv: collected %f dBms.\n",
				oi->station->name, oi->total_dBms);
	free(oi);
}
#endif // ifdef DEFINE_OBJECT
;


#ifdef newinstanceX
#undef newinstanceX
#endif

#define newinstanceX(sub, obj) new_ ## sub ## obj

struct obj_instance(OBJ_NAME)* newinstance(SUB_NAME, OBJ_NAME) (struct station* st);
#ifdef DEFINE_OBJECT

#define namevarX(sub, obj) name_ ## sub ## obj
#ifdef SKIP_INSTANCE
const char* namevar(SUB_NAME, OBJ_NAME) = S(SUB_NAME) S(OBJ_NAME);
#else
const char* namevar(SUB_NAME, OBJ_NAME);
#endif

#ifndef NOCODE
struct obj_instance(OBJ_NAME)* newinstance(SUB_NAME, OBJ_NAME) (
				struct station* st) {
	struct obj_instance(OBJ_NAME)* oi = malloc(
				sizeof(struct obj_instance(OBJ_NAME)));
	
	oi->station = st;
	oi->thename = namevar(SUB_NAME, OBJ_NAME);
	oi->total_dBms = 0;
	oi->exp_factor_precalc = log(EXPONENTIAL_BASIS_PWRCUM)/log(10);
	
	oi->destroy = finaldestroy(SUB_NAME, OBJ_NAME);
	
	return oi;
}
#endif // - ifndef NOCODE
#endif // ifdef DEFINE_OBJECT


#undef finaldestroyX
#undef namevarX




