

// © 2018 Jonas Bechtel
// Licensed under the Apache License, Version 2.0; see file <prj>/meta/LICENSE



#ifndef TRANCV_USER_H
#define TRANCV_USER_H

#include "object.h"

#ifdef OBJ_NAME // sometimes "app" and "route" objects were included before.
#undef OBJ_NAME
#endif

#define OBJ_NAME trancv


struct obj_instance(OBJ_NAME);


#include "sim-common.h"
#include "station-trancv.h"


// TODO: define more methods here.
#define TRANCV_INSTANCE_HEADER \
	struct station* station; \
	const char* thename; \
	/* How many seconds the station was exposed to 1 dBm \
	   (or equivalently at other strengths) */ \
	double total_dBms; \
	double exp_factor_precalc; \
	\
	void (*destroy)(struct obj_instance(OBJ_NAME)*); \
	\
	void (*data_sent)(struct obj_instance(OBJ_NAME)*); \
	\
	struct wave_sequence* (*modulate_data)( \
			struct obj_instance(OBJ_NAME)* oi, struct digital_packet * data); \
	\
	void (*next_wave_segment)( \
			struct obj_instance(OBJ_NAME)*, \
			struct wave_seq_segment); \
	\
	

	// destroy will be preset.
	// When you replace this, please take care that the old function (free) will be
	// called as the last action of the new function.



#ifndef SKIP_INSTANCE
	struct obj_instance(OBJ_NAME) {
		TRANCV_INSTANCE_HEADER
	};
#endif


#endif // #ifndef TRANCV_USER_H










